package com.smartframework.core.websocket;

package ..deTemp.1731158381552;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.smartframework.core.websocket.WebSocketThread;
import java.io.IOException;
import java.io.StringWriter;
import java.io.Writer;
import java.util.HashMap;
import java.util.Map;
import org.apache.log4j.Logger;

public class WebSocketMessage {
  private static Logger logger = Logger.getLogger(com.smartframework.core.websocket.WebSocketMessage.class);
  
  private String type;
  
  private String name;
  
  private String topic;
  
  private Object msg;
  
  public String getType() {
    return this.type;
  }
  
  public String getName() {
    return this.name;
  }
  
  public String getTopic() {
    return this.topic;
  }
  
  public Object getMessage() {
    return this.msg;
  }
  
  public static String packMessage(String name, String topic, Object message) {
    return packMessage(name, topic, message, null);
  }
  
  public static String packMessage(String name, String topic, Object message, String msgId) {
    ObjectMapper objectMapper = new ObjectMapper();
    Map<String, Object> map = new HashMap<>();
    map.put("type", "msg");
    map.put("name", name);
    if (msgId != null)
      map.put("_msgId", msgId); 
    map.put("topic", topic);
    map.put("msg", message);
    Writer strWriter = new StringWriter();
    try {
      objectMapper.writeValue(strWriter, map);
    } catch (IOException e) {
      logger.error("[" + name + " " + topic + "]组装消息失败:", e);
      return null;
    } 
    return strWriter.toString();
  }
  
  public static com.smartframework.core.websocket.WebSocketMessage unpackMessage(String message) {
    com.smartframework.core.websocket.WebSocketMessage wsMessage = null;
    try {
      ObjectMapper objectMapper = new ObjectMapper();
      Map<String, Object> maps = objectMapper.<Map<String, Object>>readValue(message, (Class)Map.class);
      if (null == maps || maps.size() < 2) {
        logger.error("消息 :" + message + "格式错误.");
        return null;
      } 
      wsMessage = new com.smartframework.core.websocket.WebSocketMessage();
      wsMessage.type = (String)maps.get("type");
      wsMessage.name = (String)maps.get("name");
      wsMessage.topic = String.valueOf(maps.get("topic"));
      wsMessage.msg = maps.get("msg");
      if (null == wsMessage.type) {
        wsMessage.type = WebSocketThread.Type.recvive.toString();
        logger.debug("消息 :" + message + "格式错误:消息没有type");
      } 
    } catch (IOException e) {
      logger.error("读取消息异常:", e);
      return null;
    } 
    return wsMessage;
  }
}
